﻿
// spn_hextohDlg.cpp : 実装ファイル
//

#include "pch.h"
#include "framework.h"
#include "spn_hextoh.h"
#include "spn_hextohDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// アプリケーションのバージョン情報に使われる CAboutDlg ダイアログ

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// ダイアログ データ
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV サポート

// 実装
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CspnhextohDlg ダイアログ



CspnhextohDlg::CspnhextohDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_SPN_HEXTOH_DIALOG, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CspnhextohDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CspnhextohDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DROPFILES()
END_MESSAGE_MAP()


// CspnhextohDlg メッセージ ハンドラー

BOOL CspnhextohDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// "バージョン情報..." メニューをシステム メニューに追加します。

	// IDM_ABOUTBOX は、システム コマンドの範囲内になければなりません。
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != nullptr)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// このダイアログのアイコンを設定します。アプリケーションのメイン ウィンドウがダイアログでない場合、
	//  Framework は、この設定を自動的に行います。
	SetIcon(m_hIcon, TRUE);			// 大きいアイコンの設定
	SetIcon(m_hIcon, FALSE);		// 小さいアイコンの設定

	// TODO: 初期化をここに追加します。
	SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);

	return TRUE;  // フォーカスをコントロールに設定した場合を除き、TRUE を返します。
}

void CspnhextohDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// ダイアログに最小化ボタンを追加する場合、アイコンを描画するための
//  下のコードが必要です。ドキュメント/ビュー モデルを使う MFC アプリケーションの場合、
//  これは、Framework によって自動的に設定されます。

void CspnhextohDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 描画のデバイス コンテキスト

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// クライアントの四角形領域内の中央
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// アイコンの描画
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// ユーザーが最小化したウィンドウをドラッグしているときに表示するカーソルを取得するために、
//  システムがこの関数を呼び出します。
HCURSOR CspnhextohDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CspnhextohDlg::OnDropFiles(HDROP hDropInfo)
{
	// TODO: ここにメッセージ ハンドラー コードを追加するか、既定の処理を呼び出します。

	int ncnt = 0;
	UINT unSize;
	TCHAR szPath[_MAX_PATH + 1];

	while (1)
	{
		unSize = ::DragQueryFile(hDropInfo, ncnt++, szPath, _MAX_PATH);
		if (unSize <= 0)
			break;

		Convertfile(szPath);
	}

	CDialogEx::OnDropFiles(hDropInfo);
}


void CspnhextohDlg::Convertfile(CString filename)
{
	wchar_t szDrive[_MAX_DRIVE];
	wchar_t szDir[_MAX_DIR];
	wchar_t szFileName[_MAX_FNAME];
	wchar_t szExt[_MAX_EXT];
	_wsplitpath_s(filename, szDrive, szDir, szFileName, szExt);

	CString outfname, ext;
	bool hextype = false;
	ext = szExt;
	if (ext.MakeLower() == L".hex") {
		outfname.Format(L"%s%s%s.h", szDrive, szDir, szFileName);
		hextype = true;
	}
	else
		outfname.Format(L"%s%s%s_c.h", szDrive, szDir, szFileName);

	//https://blog.systemjp.net/entry/2015/09/26/094512
	//https://faithandbrave.hateblo.jp/entry/20080724/1216890457
	CFile outfile;
	FILE* fp;
	errno_t ferr;

	if (hextype) {
		ferr = _tfopen_s(&fp, filename, _T("r"));
		if (0 != ferr) {
			AfxMessageBox(L"ファイルの読み込みに失敗しました");
			return;
		}
	}
	else {
		ferr = _tfopen_s(&fp, filename, _T("r, ccs=UTF-16LE"));
		if (0 != ferr) {
			AfxMessageBox(L"ファイルの読み込みに失敗しました");
			return;
		}
	}
	CStdioFile infile(fp);

	if (!outfile.Open(outfname, CFile::modeWrite | CFile::typeBinary | CFile::modeCreate)) {
		infile.Close();
		AfxMessageBox(L"ファイルの作成に失敗しました");
		return;
	}

	CString buff, outtext;
	CStringA outtext_a;
	int linecount = 1;
	int unitcount = 0;
	while (infile.ReadString(buff)) {
		if (hextype) {
			if (buff.GetLength() == 19 && buff.Left(3) == L":04") {
				//const unsigned char ROM_00[] PROGMEM = {
				if (linecount == 1) {
					outtext.Format(L"const unsigned char ROM_%02d[] PROGMEM = {\r\n", (linecount / 130));
					outtext_a = outtext;
					outfile.Write(outtext_a, outtext_a.GetLength());
					linecount++;
				}
				else if (linecount > 100 && linecount % 130 == 0) {
					outtext.Format(L"};\r\nconst unsigned char ROM_%02d[] PROGMEM = {\r\n", (linecount / 130));
					outtext_a = outtext;
					outfile.Write(outtext_a, outtext_a.GetLength());
					linecount += 2;
				}
				outtext.Format(L"0x%s,0x%s,0x%s,0x%s,\r\n", buff.Mid(9, 2), buff.Mid(11, 2), buff.Mid(13, 2), buff.Mid(15, 2));
				outtext_a = outtext;
				outfile.Write(outtext_a, outtext_a.GetLength());
				linecount++;
			}
		}
		else {
			if (buff.Find(L"[]") != -1) {
					outtext.Format(L"const unsigned char ROM_%02d[] PROGMEM = {\r\n", unitcount++);
			}else
				outtext = buff + L"\r\n";
			outtext_a = outtext;
			outfile.Write(outtext_a, outtext_a.GetLength());
		}
	}
	if (hextype) {
		outtext = L"};\r\n";
		outtext_a = outtext;
		outfile.Write(outtext_a, outtext_a.GetLength());
	}

	outfile.Close();
	infile.Close();
	//AfxMessageBox(L"完了", MB_ICONINFORMATION);
}
